<?php
/**
 * ------------------------------------------------------------------------
 * JA Filter Plugin - Eshop
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2016 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */
 
// No direct access to this file
defined('_JEXEC') or die('Restricted access');

class JFormFieldFilterfields extends JFormFieldJaMegafilter_filterfields
{
	protected $type = 'filterfields';

	function getFieldGroups()
	{
		$class_methods = get_class_methods($this);
		$fl_array = preg_grep('/getJaMegafilterField(.*?)/', $class_methods);
		
		$fieldgroups = array();
		foreach ($fl_array as $value) {
			$array_key = strtolower( substr($value, 20) );
			$fieldgroups[$array_key] = $this->{ $value }();
		}
		return $fieldgroups;
	}
	
	function getJaMegafilterFieldBaseField()
	{
		$basefield = array(
			array(
				"published"=>0,
				"sort" => 0,
				"field"=> "name",
				"title"=>JText::_("COM_JAMEGAFILTER_TITLE"),
				"name"=>JText::_("COM_JAMEGAFILTER_TITLE"),
				"filter_type"=>array("value")
			),

			array(
				"published"=>0,
				"sort" => 0,
				"field"=> "pprice",
				"title"=>JText::_("COM_JAMEGAFILTER_PRICE"),
				"name"=>JText::_("COM_JAMEGAFILTER_PRICE"),
				"filter_type"=>array("range")
			),

			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "attr.cat.value",
				"title"=>JText::_("COM_JAMEGAFILTER_CATEGORY"),
				"name"=>JText::_("COM_JAMEGAFILTER_CATEGORY"),
				"filter_type"=>array("single", "dropdown", "multiple")
			),

			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "attr.manu.value",
				"title"=>JText::_("COM_JAMEGAFILTER_MANUFACTURER"),
				"name"=>JText::_("COM_JAMEGAFILTER_MANUFACTURER"),
				"filter_type"=>array("single", "dropdown", "multiple")
			),	
			array(
					"published" => 0,
					"sort" => 0,
					"field" => "attr.featured.value",
					"title" => JText::_("COM_JAMEGAFILTER_FEATURED"),
					"name" => JText::_("COM_JAMEGAFILTER_FEATURED"),
					"filter_type" => array("single", "dropdown", "multiple")
			),				
			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "rating",
				"title"=>JText::_("COM_JAMEGAFILTER_RATING"),
				"name"=>JText::_("COM_JAMEGAFILTER_RATING"),
				"filter_type"=>array("range")
			),

			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "product_height",
				"title"=>JText::_("COM_JAMEGAFILTER_HEIGHT"),
				"name"=>JText::_("COM_JAMEGAFILTER_HEIGHT"),
				"filter_type"=>array("range")
			),

			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "product_width",
				"title"=>JText::_("COM_JAMEGAFILTER_WIDTH"),
				"name"=>JText::_("COM_JAMEGAFILTER_WIDTH"),
				"filter_type"=>array("range")
			),
			
			array(
				"published"=>0,
				"sort" => 0,	
				"field"=> "attr.tag.value",
				"title"=>JText::_("COM_JAMEGAFILTER_TAG"),
				"name"=>JText::_("COM_JAMEGAFILTER_TAG"),
				"filter_type"=>array("single", "dropdown", "multiple")
			),		

		);
		return $basefield;
	}

	function getJaMegafilterFieldCustomField()
	{
		$customfields = EshopHelper::getAttributeGroups();
		$customfield = array();
		
		foreach ($customfields as $field) 
		{
			$customfield[] = array(
				"published" => 0,
				"sort" => 0,	
				"field" => 'attr.ct'.$field->id.'.value',
				"title" => $field->attributegroup_name,
				"name" => $field->attributegroup_name,
				"filter_type" => array( "single", "dropdown", "multiple", "color" )
				);
		}

		return $customfield;
	}
	
	function getJaMegafilterFieldOptionsField()
	{
		$currentLanguage = JFactory::getLanguage();
		$currentTag = $currentLanguage->getTag();
		$db = JFactory::getDbo();
		$optionsfields = EshopHelper::getAttributeGroups();
		$sql = 'SELECT * FROM #__eshop_options o
				LEFT JOIN #__eshop_optiondetails od ON (od.option_id = o.id)
				WHERE od.language IN ("*", "'.$currentTag.'") AND o.published = 1';
		$db->setQuery($sql);
		$options = $db->loadObjectList();
		$optionsfield = array();

		foreach ($options as $field) 
		{
			if (!in_array($field->option_type, array('Select','Radio','Checkbox'))) continue;
			$optionsfield[] = array(
				"published" => 0,
				"sort" => 0,
				"field" => 'attr.op'.$field->id.'.value',
				"title" => $field->option_name,
				"name" => $field->option_name,
				"filter_type" => array( "single", "dropdown", "multiple", "color" )
				);
		}

		return $optionsfield;
	}
}