<?php
/**
 * ------------------------------------------------------------------------
 * JA Filter Plugin - Eshop
 * ------------------------------------------------------------------------
 * Copyright (C) 2004-2016 J.O.O.M Solutions Co., Ltd. All Rights Reserved.
 * @license - GNU/GPL, http://www.gnu.org/licenses/gpl.html
 * Author: J.O.O.M Solutions Co., Ltd
 * Websites: http://www.joomlart.com - http://www.joomlancers.com
 * This file may not be redistributed in whole or significant part.
 * ------------------------------------------------------------------------
 */
 
defined('_JEXEC') or die;

class EshopFilterHelper 
{
	function getFilterItems($catid)
	{
		$config = EshopHelper::getConfig();
		$categories = EshopHelper::getAllChildCategories($catid);
		$categories[] = $catid;
		$lang = JFactory::getLanguage();
		$languages = JLanguageHelper::getLanguages();
		$filterItems = array();
		foreach ($languages AS $lang) {
			$filterItems[str_replace('-', '_', strtolower($lang->lang_code))] = $this->getItemList($categories, $lang);
		}
		return $filterItems;
	}
	
	function getItemList($categories, $lang) {
		$item = new stdClass();
		$itemIdList = $this->getProductCategories($categories, $lang->lang_code);
		$itemList = new stdCLass();
		foreach ($itemIdList as $id) {
			$property = 'item_'.$id;
			$item = $this->getItem($id, $lang, $categories);
			if( !empty($item))
				$itemList->{ $property } = $item;
			else
				continue;
		}
		return $itemList;
	}
	
	function getItem($id, $lang, $categories) {
		$db = JFactory::getDbo();
		$item = new stdClass();
		$item->attr = array();
		$baseItem = EshopHelper::getProduct($id, $lang->lang_code);
		$item->id = $id;
		$item->name = $baseItem->product_name;
		$currency = new EshopCurrency();
		$item->pprice = intval($baseItem->product_price);
		$item->is_salable = 1;
		$item->frontend_price = $currency->format($baseItem->product_price);
		$item->rating = ceil(EshopHelper::getProductRating($id));
		$item->width_rating = $item->rating*20;
		$item->product_width = $baseItem->product_width;
		$item->product_height = $baseItem->product_height;
		$item->created_date = strtotime($baseItem->created_date);
		$item->modified_date = strtotime($baseItem->modified_date);
		$item->shopper_groups = !empty($baseItem->product_customergroups) ? explode(',',$baseItem->product_customergroups) : array();

		$maincat = EshopHelper::getProductCategory($id);
		$item->url = ''; // set url by blank, so we know we override later at default.php layout
		$item->maincat = $maincat; // need catid for override.

		// get image from eshop
		$thumbImageSizeFunction = EshopHelper::getConfigValue('thumb_image_size_function', 'resizeImage');
		// Main image resize
		if ($baseItem->product_image && JFile::exists(JPATH_ROOT.'/media/com_eshop/products/' . $baseItem->product_image))
		{
			if (EshopHelper::getConfigValue('product_use_image_watermarks'))
			{
				$watermarkImage = EshopHelper::generateWatermarkImage(JPATH_ROOT . '/media/com_eshop/products/' . $baseItem->product_image);
				$productImage = $watermarkImage;
			}
			else
			{
				$productImage = $baseItem->product_image;
			}
			$thumbImage = call_user_func_array(array('EshopHelper', $thumbImageSizeFunction), array($productImage, JPATH_ROOT . '/media/com_eshop/products/', EshopHelper::getConfigValue('image_thumb_width'), EshopHelper::getConfigValue('image_thumb_height')));
		}
		else
		{
			$thumbImage = call_user_func_array(array('EshopHelper', $thumbImageSizeFunction), array('no-image.png', JPATH_ROOT . '/media/com_eshop/products/', EshopHelper::getConfigValue('image_thumb_width'), EshopHelper::getConfigValue('image_thumb_height')));
		}
		$item->thumbnail = 'media/com_eshop/products/resized/' . $thumbImage;

		$_categories = EshopHelper::getProductCategories($id, $lang->lang_code);
		$item->attr['cat'] = array();
		foreach ($_categories AS $cat) {
			if (!in_array($cat->id, $categories)) continue;
			$parent = EshopHelper::getParentCategories($cat->id, $lang->lang_code);
			$catname='';
			if (count($parent) > 1) {
				for ($i=count($parent)-1;$i>=0;$i--) {
					$catname .= $parent[$i]->category_name.' » ';
				}
			} else {
				$catname = $cat->category_name;
			}
			$catname = rtrim($catname, ' » ');
			$item->attr['cat']['value'][] = $cat->id;
			$item->attr['cat']['frontend_value'][] = $catname;
		}
		
		$item->attr['featured']['value'][] = (string) $baseItem->product_featured;
		if ($baseItem->product_featured) {
			$item->attr['featured']['frontend_value'][] = JText::_('COM_JAMEGAFILTER_ONLY_FEATURED');
		} else {
			$item->attr['featured']['frontend_value'][] = JText::_('COM_JAMEGAFILTER_NOT_FEATURED');
		}
		
		$tags = EshopHelper::getProductTags($id);
		$item->attr['tag'] = array();
		foreach ($tags AS $tag) {
			$item->attr['tag']['value'][] = $tag->id;
			$item->attr['tag']['frontend_value'][] = $tag->tag_name;
		}

		$manufacturers = EshopHelper::getProductManufacturer($id, $lang->lang_code);
		$item->attr['manu'] = array();
		$item->attr['manu']['value'][] = $manufacturers->id;
		$item->attr['manu']['frontend_value'][] = $manufacturers->manufacturer_name;
		
		$attributes = EshopHelper::getProductAttributes($id, $lang->lang_code);
		foreach ($attributes AS $att) {
			$groups = EshopHelper::getAttributeAttributeGroup($att->id, $lang->lang_code);
			$sql = 'SELECT id FROM #__eshop_attributegroups WHERE published=1 AND id = '.$groups->attributegroup_id;
			$db->setQuery($sql);
			$rows = $db->loadColumn();
			if (empty($rows)) continue;
			$sql = 'SELECT ad.attribute_name FROM #__eshop_attributedetails ad
					LEFT JOIN #__eshop_attributes a ON (ad.attribute_id = a.id)
					WHERE a.published = 1
					AND ad.attribute_id = '.$att->id;
			$db->setQuery($sql);
			$rows = $db->loadColumn();
			if (empty($rows)) continue;
			$item->attr['ct'.$groups->attributegroup_id]['value'][] = $att->id;
			$item->attr['ct'.$groups->attributegroup_id]['frontend_value'][] = $rows[0];
		}

		// options fields.
		$options = EshopHelper::getProductOptions($item->id);
		foreach ($options AS $option) {
			if (!in_array($option->option_type, array('Select','Radio','Checkbox'))) continue;
			$values = EshopHelper::getProductOptionValues($item->id, $option->id);
			foreach ($values AS $value) {
				$optionvalues = EshopHelper::getOptionValues($value->option_id);
				foreach ($optionvalues AS $opv) {
					if ($value->option_value_id != $opv->optionvaluedetails_id) continue;
					$item->attr['op'.$opv->option_id]['value'][] = $opv->option_id.''.$opv->optionvaluedetails_id;
					$item->attr['op'.$opv->option_id]['frontend_value'][] = $opv->value;
				}
			}
		}

		$labels = EshopHelper::getProductLabels($item->id);
		$strlabel = '';
		for ($i = 0; $n = count($labels), $i < $n; $i++)
		{
			$label = $labels[$i];
			if ($label->label_style == 'rotated' && !($label->enable_image && $label->label_image))
			{
				$strlabel .= '<div class="cut-rotated">';
			}
			if ($label->enable_image && $label->label_image)
			{
				$imageWidth = $label->label_image_width > 0 ? $label->label_image_width : EshopHelper::getConfigValue('label_image_width');
				if (!$imageWidth)
					$imageWidth = 50;
				$imageHeight = $label->label_image_height > 0 ? $label->label_image_height : EshopHelper::getConfigValue('label_image_height');
				if (!$imageHeight)
					$imageHeight = 50;
				$strlabel .= '<span class="horizontal '.$label->label_position.' small-db" style="opacity: '.$label->label_opacity.';background-image: url(' . str_replace('administrator/','',$label->label_image) . '); background-repeat: no-repeat; width: '.$imageWidth.'px; height: '.$imageHeight.'px; box-shadow: none;"></span>';
			}
			else 
			{
				$strlabel .= '<span class="'.$label->label_style.' '.$label->label_position.' small-db" style="float:left;background-color: #'.$label->label_background_color.'; color: #'.$label->label_foreground_color.'; opacity: '.$label->label_opacity.';'.($label->label_bold ? 'font-weight: bold;' : '').'">'.$label->label_name.'</span>';
			}
			if ($label->label_style == 'rotated' && !($label->enable_image && $label->label_image))
			{
				$strlabel .= '</div>';
			}
		}
		$item->labels = $strlabel;

		return $item;
	}
	
	public function getProductCategories($categories, $langCode = 'en-GB')
	{
		$db = JFactory::getDbo();
		$query = $db->getQuery(true);
		$query->select('p.id')
			->from('#__eshop_products p')
			->leftJoin('#__eshop_productcategories pc ON (p.id = pc.product_id)')
			->where('pc.category_id IN ('.implode(',', $categories).')')
			->where('p.published = 1')
			->group('p.id');
		$db->setQuery($query);
		$rows = $db->loadColumn();
		return $rows;
	}
	
	public function getAllChildCategories($id)
	{
		$data = array();
		
		if ($results = EshopHelper::getCategories($id, '', true))
		{
			foreach ($results as $result)
			{
				$data[] = $result;
				$subCategories = EshopHelper::getAllChildCategories($result->id);
				if ($subCategories)
				{
					$data = array_merge($data, $subCategories);
				}
			}
		}
		return $data;
	}

}